<app-loading *ngIf="isLoadingPage"></app-loading>
<div class='content__item content__item--border bg__content--default' (keyup.enter)='doSearch()'>
  <form nz-form [formGroup]='form' style='margin-bottom: 8px'>
    <div nz-row [nzGutter]='[30,30]'>
      <!--    Form tìm kiếm -->

      <div nz-col [nzXs]='24' [nzLg]='6'>
        <mb-select [mbDataSelects]='listEmpType'
                   mbKeyLabel='label'
                   mbKeyValue='value'
                   [mbErrors]="form.controls['empTypeCode']?.errors"
                   [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.workHisInformation.label.attributes.empType' | translate}}]"
                   mbPlaceholder="--{{'staffAbs.workHisInformation.label.attributes.empType' | translate}}--"
                   mbLabelText="{{'staffAbs.workHisInformation.label.attributes.empType' | translate}}"
                   formControlName='empTypeCode'
        ></mb-select>
    </div>
    <div nz-col [nzXs]='24' [nzLg]='6'>
      <mb-input-text formControlName='keySearch' [mbMaxLength]='200'
        mbPlaceholderText="--{{'staffAbs.label.keySearchEmployee' | translate}}--"
        mbLabelText="{{'staffAbs.label.keySearchEmployee' | translate}}"></mb-input-text>
    </div>
    <div nz-col [nzXs]="24" [nzLg]="6">
      <org-data-picker mbLabelText="{{'staffAbs.timekeepingManagement.organizationId' | translate}}"
        mbPlacholder="--{{'staffAbs.timekeepingManagement.organizationIdSearch' | translate }}--"
        [functionCode]="functionCode" [scope]="scope" formControlName="organizationId"></org-data-picker>
    </div>
      <div nz-col [nzXs]="24" [nzLg]="6">
        <mb-select-check-able
                    [mbShowAction]="false"
                    [mbDataSelects]="EMP_STATUS_DATASOURCE"
                    formControlName="empStatus"
                    mbPlaceholder="{{'staffAbs.label.empStatus' | translate }}"
                    mbLabelText="{{'staffAbs.label.empStatus' | translate}}"
                ></mb-select-check-able>
      </div>      
      <div nz-col [nzXs]='24' [nzLg]='6'>
        <mb-date-picker
          [mbType]="(isSearch && form.controls['fromDate'].errors || form.errors?.rangeDateError) ? 'error' : 'default'"
          [mbShowError]="(isSearch && form.controls['fromDate'].errors || form.errors?.rangeDateError) !== null"
          [mbErrors]="form.errors?.rangeDateError ? form.errors : form.controls['fromDate'].errors"
          [mbErrorDefs]="[
          { errorName: 'required', errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.label.fromDate' | translate }},
          { errorName: 'rangeDateError', errorDescription: 'staffAbs.validate.rangeDate.pareDate' | translate:
        {'fromDate': 'staffAbs.label.fromDate' | translate, 'toDate': 'staffAbs.label.toDate' | translate}}
          ]"
          mbPlaceholderText="--{{'staffAbs.label.fromDate' | translate}}--"
          mbLabelText="{{'staffAbs.label.fromDate' | translate}} <span class='label__required'>*</span>"
          formControlName='fromDate'></mb-date-picker>
      </div>

      <!-- Đến ngày -->
      <div nz-col [nzXs]='24' [nzLg]='6'>
        <mb-date-picker
          [mbType]="isSearch && form.controls['toDate'].errors ? 'error' : 'default'"
          [mbShowError]="isSearch && form.controls['toDate'].errors !== null"
          [mbErrors]="form.controls['toDate'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.label.toDate' | translate }}]"
          mbPlaceholderText="--{{'staffAbs.label.toDate' | translate}}--"
          mbLabelText="{{'staffAbs.label.toDate' | translate}} <span class='label__required'>*</span>"
          formControlName='toDate'></mb-date-picker>
      </div>
      <!--    End Form tìm kiếm-->
    </div>
  </form>

  <div nz-row class="btn__row">
    <div nz-col nzSpan="8"></div>

    <div nz-col nzSpan="8">
      <div style="text-align: center">
        <mb-button
          class="staff__research__btn__search"
          mbButtonSize="MEDIUM"
          mbButtonAvailableStyle="SEARCH"
          (click)="doSearch(1)"
          mbButtonText="{{'staffAbs.label.search' | translate}}"
        ></mb-button>
        <mb-button
          mbButtonSize="MEDIUM"
          *ngIf="objFunction.create"
          mbButtonAvailableStyle="PRIMARY"
          mbButtonText="{{'staffAbs.label.timekeepingAuto' | translate}}"
          nz-popconfirm
          nzCancelText="{{'staffAbs.table.action.cancel' | translate}}" nzOkType="primary"
          nzPopconfirmTitle="{{'staffAbs.label.timekeepingAutoConfirm' | translate }}"
          nzPopconfirmPlacement="left"
          nzOkText="{{'staffAbs.table.action.yes' | translate}}"
          (nzOnConfirm)="timekeepingAuto()"
        ></mb-button>
        <mb-button
          mbButtonSize="MEDIUM"
          mbButtonType="BORDER"
          nz-dropdown [nzDropdownMenu]="menu"
        >
        <!-- (click)="doExportData()" -->
          <img src="/assets/icon/staff-manager/export_excel.svg" alt=""/>
        </mb-button>
      </div>
    </div>
    <div nz-col nzSpan="8"></div>
  </div>

</div>

<ng-container>
  <nz-dropdown-menu #menu="nzDropdownMenu">
      <div>
          <ul nz-menu >
              <em nz-menu-item (click)="doExportData()">{{'staffAbs.label.exportTimeKeepingCurrent' | translate }}</em>
              <em nz-menu-item (click)="prepareExport(ExportType.AT_TIME, footerExportTmpl)" *ngIf="objFunctionReport?.view">{{'staffAbs.label.exportTimeKeepingAtTime' | translate }}</em>
              <em nz-menu-item (click)="prepareExport(ExportType.CHANGED, footerExportTmpl)" *ngIf="objFunctionReport?.export">{{'staffAbs.label.exportTimeKeepingChanged' | translate }}</em>
          </ul>
      </div>
  </nz-dropdown-menu>
</ng-container>


<div class="search__result">
  <p style='font-size: 18px; font-weight: 600'>{{'staffAbs.label.timekeeping' | translate}}</p>
  <nz-table
    #basicTable
    [nzData]='searchResult'
    [nzLoading]='loading'
    [nzFrontPagination]='false'
    [nzShowPagination]='searchResult?.length < count'
    [nzTotal]='count'
    [nzPageSize]='pagination.pageSize'
    [(nzPageIndex)]='pagination.pageNumber'
    (nzPageIndexChange)='doSearch($event)'
    nzSize='small'
    class='data-table'
    nzShowPagination
    [nzScroll]="nzScrollWidth > innerWidth ? {x: nzScrollWidth + 'px'} : {}"
    nzBordered
  >
    <thead>
    <tr>
      <th scope='col'  nzLeft class='text-nowrap' nzAlign='center' nzWidth='80px'
          rowSpan='2'>{{'staffAbs.label.stt' | translate}}</th>
      <th scope='col'  nzLeft class='text-nowrap' nzAlign='center' nzWidth='140px'
          rowSpan='2'>{{'staffAbs.label.staffCode' | translate}}</th>
      <th scope='col'  nzLeft class='text-nowrap' nzAlign='center' nzWidth='180px'
          rowSpan='2'>{{'staffAbs.label.fullName' | translate}}</th>
      <th scope='col'  class='text-nowrap' nzAlign='center' nzWidth='100px'
          rowSpan='2'>{{'staffAbs.label.employeeType' | translate}}</th>
      <th scope='col'  class='text-nowrap' nzAlign='center' nzWidth='100px'
          rowSpan='2'>{{'staffAbs.label.positionName' | translate}}</th>
      <th scope='col'  class='text-nowrap' nzAlign='center' nzWidth='250px'
          rowSpan='2'>{{'staffAbs.label.organization' | translate}}</th>
      <th scope='col'  class='text-nowrap' nzAlign='center' [colSpan]='colSpan'>{{'staffAbs.label.listMonth' | translate}}</th>
    </tr>
    <tr>
      <th class='text-nowrap' nzAlign='center' *ngFor='let day of basicTable.data[0]?.listTimeKeeping'>
        <span *ngIf="day.dayOfWeek === 'T7' || day.dayOfWeek === 'CN'" style="color: red;">
          {{day.dayOfMonth}} <br/> {{"(" + day.dayOfWeek + ")"}}
        </span>
        <span *ngIf="day.dayOfWeek !== 'T7' && day.dayOfWeek !== 'CN'">
          {{day.dayOfMonth}} <br/> {{"(" + day.dayOfWeek + ")"}}
        </span>
      </th>
    </tr>
    </thead>
    <tbody>
    <tr *ngFor='let data of basicTable.data; let i = index'>
      <td nzLeft
          nzAlign='center'>{{validateService.getRowIndex(i, basicTable.nzPageIndex, basicTable.nzPageSize)}}</td>
      <td nzLeft>{{data.employeeCode}}</td>
      <td nzLeft>{{data.fullName}}</td>
      <td>{{data.empTypeName}}</td>
      <td>{{data.positionName}}</td>
      <td>{{data.orgName}}</td>
      <td class='text-nowrap' nzAlign='center' *ngFor='let day of data.listTimeKeeping'>
          <span *ngIf='day.workdayTypeCode && day.totalHours'>
            {{day?.timekeeping}}
          </span>
      </td>
    </tr>
    </tbody>
  </nz-table>
</div>

<!-- Footer Tu choi phe duyet backdate -->
<ng-template #footerExportTmpl>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal?.destroy()" mbButtonBgColor="transparent"
    mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal?.getContentComponent().save()"
    mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'staffAbs.label.export' | translate}}"></mb-button>
</ng-template>